/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package imagecreation;


import com.mysql.jdbc.exceptions.MySQLIntegrityConstraintViolationException;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import org.omg.PortableInterceptor.SYSTEM_EXCEPTION;

/**
 *
 * @author admin
 */
public class DBConnection {
private java.sql.Connection con;
private java.sql.PreparedStatement pstmt1,pstmt2,pstmt3;
private ResultSet result;
private int count;
    public DBConnection()
    {
    try {
        Class.forName("com.mysql.jdbc.Driver");
        con = DriverManager.getConnection("jdbc:mysql://localhost:3306/flex_printing", "root", "12345");
        
    } catch (ClassNotFoundException ex) {
        Logger.getLogger(DBConnection.class.getName()).log(Level.SEVERE, null, ex);
    }catch (SQLException ex) {
        Logger.getLogger(DBConnection.class.getName()).log(Level.SEVERE, null, ex);
    }
            
            
        
    }
         
     public ResultSet getItemFromStockHavingNonZeroSqFtOrQuantity ()throws SQLException
    {
        pstmt1=con.prepareStatement("select Item_Name from stock where Sq_Ft > 0 || Quantity > 0");
        result=pstmt1.executeQuery();
        
     return result;
    }
     
     
     
    public int getItemIDByNameFromStock(String Item_Name)throws SQLException
    {
    
        pstmt1=con.prepareStatement("select Item_ID from stock where Item_Name=?");
        pstmt1.setString(1, Item_Name);
        result=pstmt1.executeQuery();
        result.next();
    
     return result.getInt(1);
    }
     
    public float getMRPPerUnitByIDsFromPerClientItemRateDetails(int Client_ID,int Item_ID)throws SQLException
    {
    
        pstmt1=con.prepareStatement("select MRPPerUnit from per_client_item_rate_details where Client_ID=? and Item_ID=?");
        pstmt1.setInt(1, Client_ID);
        pstmt1.setInt(2, Item_ID);
        result=pstmt1.executeQuery();
        result.next();
     return result.getFloat(1);
    }
    
    
    public ResultSet getLoggedUser() throws SQLException
    {
        pstmt1=con.prepareStatement("select * from logged_user");
        result=pstmt1.executeQuery();
                
     return result;
    }
    
    public int setClientEntry(String Client_Name,String Address,long Contact_No,
                                String Email_ID,String LBT_No,String Vendor_No,String Wat_No,String Type) throws SQLException 
    {
        count=getClientCount();
        count++;
                
        pstmt1=con.prepareStatement("insert into client_entry values(?,?,?,?,?,?,?,?,?)");
        pstmt1.setInt(1, count);
        pstmt1.setString(2, Client_Name);
        pstmt1.setString(3, Address);
        pstmt1.setLong(4, Contact_No);
        pstmt1.setString(5, Email_ID);
        pstmt1.setString(6, LBT_No);
        pstmt1.setString(7, Vendor_No);
        pstmt1.setString(8, Wat_No);
        pstmt1.setString(9, Type);
        
        pstmt1.executeUpdate();
        pstmt1.close();
     return count;
       }
   
     public void setPerClientItemRateDetails(int Client_ID,int Item_ID,float MRPPerUnit) throws SQLException
    {
        pstmt3=con.prepareStatement("insert into per_client_item_rate_details values(?,?,?)");
        
        pstmt3.setInt(1, Client_ID);
        pstmt3.setInt(2, Item_ID);
        pstmt3.setFloat(3, MRPPerUnit);
        pstmt3.executeUpdate();
    }
        
     public java.sql.ResultSet getClientEntryByID(int ClientID) throws SQLException
    {
        pstmt1=con.prepareStatement("select * from client_entry where Client_ID=?");
        pstmt1.setInt(1, ClientID);
        result=pstmt1.executeQuery();
     return result;
    }
     
     public int getClientCount()throws SQLException
    {
        pstmt1=con.prepareStatement("select count(*) from client_entry");
        result=pstmt1.executeQuery();
        result.next();
        
       return result.getInt(1);
    }
     
     public ResultSet getClientIDNamesFromClientEntry() throws SQLException
    {
        pstmt1=con.prepareStatement("select Client_ID,Client_Name from client_entry");
        result=pstmt1.executeQuery();
     return result;
    }
     
     
     
 public ResultSet getStock() throws SQLException
    {
        pstmt1=con.prepareStatement("select * from stock");
        result=pstmt1.executeQuery();
     return result;
    } 
 
 public float getItemLengthByNameFromStock(String ItemName)throws SQLException
    {

        pstmt1=con.prepareStatement("select Length from stock where Item_Name=?");
        pstmt1.setString(1, ItemName);
            
        result=pstmt1.executeQuery();
        result.next();
     return result.getFloat(1);
    } 
 
 public float getItemWidthByNameFromStock(String ItemName)throws SQLException
    {

        pstmt1=con.prepareStatement("select Width from stock where Item_Name=?");
        pstmt1.setString(1, ItemName);
            
        result=pstmt1.executeQuery();
        result.next();
     return result.getFloat(1);
    } 
 
 public float getItemSqFtByIDFromStock(int ItemID)throws SQLException
    {

        pstmt1=con.prepareStatement("select Sq_Ft  from stock where Item_ID=?");
        pstmt1.setInt(1, ItemID);
            
        result=pstmt1.executeQuery();
        result.next();
     return result.getFloat(1);
    }
 
     public void setStock(int Item_ID,String Item_Name,boolean Piece,float Length,float Width,float MRPPerSqFt,float PurchaseRatePerSqFt,int Quantity) throws SQLException
    {          
        pstmt3=con.prepareStatement("insert into stock values(?,?,?,?,?,?,?,?,?)");
        
        pstmt3.setInt(1, Item_ID);
        pstmt3.setString(2, Item_Name);
        pstmt3.setBoolean(3, Piece);
        pstmt3.setFloat(4, Length);
        pstmt3.setFloat(5, Width);
        pstmt3.setFloat(6, (float)(Length*Width));
        pstmt3.setFloat(7, MRPPerSqFt);
        pstmt3.setFloat(8, PurchaseRatePerSqFt);
        pstmt3.setInt(9, Quantity);
        pstmt3.executeUpdate();
    }
     
     public void UpdateStock(String ItemName,float Length,float Width,float MRPPerSqFt,float PurchaseRatePerSqFt) throws SQLException
    {      
        pstmt3=con.prepareStatement("Update stock Set Length=?,width=?,Sq_Ft=?,MRPPerSqFt=?,PurchaseRatePerSqFt=?  where Item_Name=?");
        
        pstmt3.setFloat(1, Length);
        pstmt3.setFloat(2, Width);
        pstmt3.setFloat(3, (float)Length*Width);
        pstmt3.setFloat(4, MRPPerSqFt);
        pstmt3.setFloat(5, PurchaseRatePerSqFt);
        pstmt3.setString(6, ItemName);
        pstmt3.executeUpdate();
                
    }

     public void UpdateStock(String Item_Name,float Length,float SqFt) throws SQLException
    {      
        pstmt3=con.prepareStatement("Update stock Set Length=?,width=?,Sq_Ft=? where Item_Name=?");
        
        pstmt3.setFloat(1, Length);
        pstmt3.setFloat(2, getItemWidthByNameFromStock(Item_Name));
        pstmt3.setFloat(3, SqFt);
        pstmt3.setString(4, Item_Name);
        pstmt3.executeUpdate();
                
    }
     
     public void UpdateStock(String Item_Name,int Quantity,float MRPPerSqFt,float PurchaseRatePerSqFt) throws SQLException
    {      
        pstmt3=con.prepareStatement("Update stock Set MRPPerSqFt=?,PurchaseRatePerSqFt=?,Quantity=? where Item_Name=?");
        
        pstmt3.setFloat(1, MRPPerSqFt);
        pstmt3.setFloat(2, PurchaseRatePerSqFt);
        pstmt3.setInt(3, Quantity);
        pstmt3.setString(4, Item_Name);
        pstmt3.executeUpdate();             
    }
     
     public void UpdateStock(String Item_Name,int Quantity) throws SQLException
    {      
        pstmt3=con.prepareStatement("Update stock Set Quantity=? where Item_Name=?");
        
        pstmt3.setInt(1, Quantity);
        pstmt3.setString(2, Item_Name);
        pstmt3.executeUpdate();             
    }
     
    public void UpdateClientEntry(int Client_ID, String Name, String Address, long ContactNo
            , String EmailID, String LBTNo, String VendorNo,String WatNo, String Type) throws SQLException
    {
        pstmt3=con.prepareStatement("Update client_entry Set Client_Name=?,Address=?,Contact_No=?,Email_ID=?,LBT_No=?,Vendor_No=?,Wat_No=?,Type=?  where Client_ID=?");
        
        pstmt3.setString(1, Name);
        pstmt3.setString(2, Address);
        pstmt3.setLong(3, ContactNo);
        pstmt3.setString(4, EmailID);
        pstmt3.setString(5, LBTNo);
        pstmt3.setString(6, VendorNo);
        pstmt3.setString(7, WatNo);
        pstmt3.setString(8, Type);
        pstmt3.setInt(9, Client_ID);
        pstmt3.executeUpdate();
                
        
        }

    public void UpdatePerClientItemRateDetails(int Client_ID, int Item_ID, float MRPPerUnit) throws SQLException {
        pstmt3=con.prepareStatement("Update per_client_item_rate_details Set MRPPerUnit=?  where Client_ID=? and Item_ID=?");
        
        pstmt3.setFloat(1, MRPPerUnit);
        pstmt3.setInt(2, Client_ID);
        pstmt3.setInt(3, Item_ID);
        pstmt3.executeUpdate();
         
    
    }
    public int getStockCount()throws SQLException
    {
        pstmt1=con.prepareStatement("select count(*) from stock");
        result=pstmt1.executeQuery();
        result.next();
        
       return result.getInt(1);
    }
         
    public boolean getWhetherPieceFromStockByName(String Item_Name)throws SQLException
    {
        pstmt1=con.prepareStatement("select Piece from stock where Item_Name=?");
        pstmt1.setString(1,Item_Name);
        result=pstmt1.executeQuery();
        result.next();
        
       return result.getBoolean(1);
    } 
public int getItemQuantityByNameFromStock(String ItemName)throws SQLException
    {

        pstmt1=con.prepareStatement("select Quantity from stock where Item_Name=?");
        pstmt1.setString(1, ItemName);
            
        result=pstmt1.executeQuery();
        result.next();
     return result.getInt(1);
    } 
 

}

